// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////
//
/**************************************************************
**        __                                          __
**     __/_/__________________________________________\_\__
**  __|_                                                  |__
** (___O)   William SerGio & Co., Inc.                   (O___)
**(_____O)	www.codearchive.com/~sergio			        (O_____)
**(_____O)	Author:	Bill SerGio, The Infomercial King   (O_____)
** (__O)	Author is listed in Who's Who in America     (O__)
**    |___________________________________________________|
****************************************************************/
/*
 * (C) Copyright 2002 by Bill SerGio, The Infomercial King.
 * All Rights Reserved Worldwide.
 * 20547 Old Cutler Road, PMB #222, Miami, FL 33189
 * www.codearchive.com/~sergio   sergio@codearchive.com  (305)233-9370
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted under this license for provided the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Licensee does not utilize the software in a manner which is disparaging
 *    to the Author and/or any products or companies of the Author.
 * 4. This code/software may NOT be used in any way by any government,federal agency,
 *    or, any employee or agent of any government or federal agency. This software is
 *    not designed or intended for use in on-line control of aircraft, air traffic, 
 *    aircraft navigation or aircraft communications; or in design, construction, 
 *    operation or maintenance of any nuclear facility. Licensee represents and 
 *    warrants that it will not use or redistribute the Software for such purposes.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR FOR EDUCATIONAL PURPOSES ONLY,
 * 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS,
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION),
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#if !defined(AFX_MAINFRM_H__D3CE7FCE_4ED3_11D6_9899_44455354616F__INCLUDED_)
#define AFX_MAINFRM_H__D3CE7FCE_4ED3_11D6_9899_44455354616F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxcmn.h>
#include "TrayStuff.h"

class CMainFrame : public CFrameWnd
{
public: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

	CString ResourceToURL(LPCTSTR lpszURL);

	//void SetViewWhileDrag();
	//BOOL GetFullDrag();
	void SetEnable(BOOL bRet);
	BOOL InstallTrayIcon(BOOL bEnable);
	void AnimateTrayIcon();
	void OnTimer(UINT nIDEvent);
	BOOL StopAnimation();
	BOOL Animate(UINT nDelayMilliSeconds, int nNumSeconds /*=-1*/);
	//void OnAppExit(); 
	//	BOOL LauchIEBrowser(CString csUrlPage);


	// --------------------------------------------------------------------------
	// GetTaskBarPosition : retrieve rectangle coordinates of taskbar window.
	// Author: Bill SerGio
	// Returns -1 : if en error occured
	//          0 : if taskbar is at left of screen
	//          1 : if taskbar is at top of screen
	//          2 : if taskbar is at right of screen
	//          3 : if taskbar is at bottom of screen
	// --------------------------------------------------------------------------
	INT	GetTaskBarPosition(RECT *pstRect = NULL);
	RECT m_rcTaskBar;
	INT  m_nTaskBarPos;
	INT  m_nMenuRight;
	INT  m_nMenuBottom;

	CString m_strDst;	// Destination path for RGN files
	CString m_strSrc;	// Source path for .BMP files

//	void LoadHTMLSkin();
//	void LoadRegionFromBMP(HBITMAP hBmp, CString csRgnFile, COLORREF cTolerance);

// Attributes
public:
    HICON		m_hSavedIcon;
	CMenu*		m_pMenu;
	BOOL		m_bTrayMenuDisplayed;	// For Skinned Menus
	UINT		m_nXPos;
	UINT		m_nYPos;
	CDialogBar	m_wndFieldChooser;
	CStringArray m_astrFavoriteURLs;



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL


// Implementation
public:

	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	void SetAddress(LPCTSTR lpszUrl);
	void StartAnimation();
	int BuildFavoritesMenu(LPCTSTR pszPath, int nStartPos, CMenu* pMenu);

private:
	CWnd*			m_pParent;


public:  // control bar embedded members
	//void LoadBrowser(CString sUrl);
	//void UpdateMsgs();
	static CWnd*	m_pThis;
	CStatusBar		m_wndStatusBar;
	CToolBar		m_wndToolBar;
	CReBar			m_wndReBar;
	CDialogBar      m_wndDlgBar;
	CComboBoxEx		m_wndAddress;
	CAnimateCtrl	m_wndAnimate;
	CTrayStuff*		m_pTrayStuff;
	COleDateTime	m_StartTime;
	int				m_nAnimationPeriod;


// Generated message map functions
protected:

	
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnAppExit();
	afx_msg void OnAppFreeStuff();
	afx_msg void OnAppNewVersion();
	afx_msg void OnAppPrefs();
	afx_msg void OnDisable();
    afx_msg void OnSysCommand( UINT nID, LPARAM lParam );
	afx_msg void OnDestroy();
	afx_msg void OnClose();
	afx_msg void OnAppLaunch();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnNotifyTrayIcon(WPARAM wParam, LPARAM lParam);
	afx_msg void DoNothing();
	afx_msg void OnNewAddress();
	afx_msg void OnNewAddressEnter();
	afx_msg void OnFavorite(UINT nID);
	afx_msg void OnDropDown(NMHDR* pNotifyStruct, LRESULT* pResult);
};
/////////////////////////////////////////////////////////////////////////////


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__D3CE7FCE_4ED3_11D6_9899_44455354616F__INCLUDED_)

